#ifndef	ARRAY_H
#define	ARRAY_H
// $Id$
#include	<assert.h> // we should use exceptions to signal errors
// a safe array class template: subscripts are checked
template <typename T>
class Array {
public:
  Array(unsigned int size =10): data_(new T[size]), size_(size) {}
  Array(const Array&);
  Array& operator=(const Array&);
  ~Array() { delete[] data_; }
  unsigned int	size() const { return size_; }
  // overloaded operator[], will check legality of index
  T& operator[](unsigned int i) { assert(i<size()); return data_[i]; }
  const T& operator[] (unsigned int i) const { assert(i<size()); return data_[i]; }
private:
  T*		data_;
  unsigned int	size_;
};

template <typename T>
Array<T>::Array(const Array& a): data_(new T[a.size()]), size_(a.size()) {
for (unsigned int i=0;(i<size_);++i)
  data_[i] = a[i];
}

template <typename T>
Array<T>&
Array<T>::operator=(const Array& a) {
if (this==&a) // self assignment
  return; 
delete [] data_;
size_ = a.size();
data_ = new T[a.size_];
for (unsigned int i=0;(i<size_);++i)
  data_[i] = a[i];
return *this;
}
#endif
