#ifndef	QSORT_H
#define	QSORT_H
template <typename T>
inline void
exchange(T* a,int i,int j) {
T tmp(a[i]);
a[i] = a[j];
a[j] = tmp;
}

template <typename T>
void
quicksort(T* a,int low,int high) { // quicksort: sort a[low..high]
if (low<high) { // area to be sorted has >1 elements
  if (a[high]<a[low]) // ensure that a[low]<= pivot, a[high]>= pivot;
    exchange(a,low,high); // this ensures that the inner loops do not run out of the range
  int lo(low);
  int hi(high+1);
  T pivot(a[low]); // we will split a[low..high] into 3 areas:
  for (;;) { // a[low..hi-1]<= pivot, a[hi]=pivot, a[hi+1..high]>= pivot
    do ++lo; while (a[lo]<pivot); // move lo to the right until a[lo]>=pivot
    do --hi; while (pivot<a[hi]); // move hi to the left until a[hi]<=pivot
    if (lo<hi) // a[lo]>=pivot and a[hi] <= pivot, thus a[hi] belongs in left part
      exchange(a,lo,hi); // and a[lo] belongs in right part: swap and continue
    else 
      break; // a[hi+1..high] >= pivot, a[low+1..hi] <= pivot and a[hi]<=pivot
    }
  exchange(a,low,hi); // now a[low..hi-1] <= pivot, a[hi] = pivot,  a[hi+1..high] >= pivot
  quicksort(a,low,hi-1);
  quicksort(a,hi+1,high);
  }
}
#endif
