#ifndef	STACK_H
#define	STACK_H
// $Id$

// A stack implementation using nested class templates.

#include	<assert.h> // It would be better to use exceptions.

template<typename Value>
class Stack {
// A Stack is represented by a linked list of Stack::Node objects.
public:
  Stack(): top_(0) {}
  ~Stack() { while (top_) pop(); }
  Stack&	push(const Value& t) { top_ = new Node(t,top_); return *this; }
  const Value&	top() const { assert(top_); return top_->item(); }
  Value		pop() { assert(top_); 
		  Node* tmp(top_->next());
		  Value value(top());
		  delete top_;
		  top_ = tmp;
		  return value;
		  }
  bool		empty() const { return top_ == 0; }
private:

  struct Node {
  // Nested class; the ``struct'' makes everything public but the
  // class itself is declared in the private section of Stack. Thus
  // Stack::Node objects are only accessible from within Stack.

    Node(const Value& v,Node* next=0): item_(v), next_(next) {}
    Node*        next() const { return next_; }
    const Value& item() const { return item_; }
    Value        item_;
    Node*        next_;
  };

  Node*		top_; // Pointer to topmost node.
};

#endif
