// $Id$ 

// Demonstration of the use of function objects.

#include	<functional> // for less<typename T>

#include	"student.h"
#include	"quicksort3.h"

// Function object class.
class LessScore {
public:
  // Example usage: given
  // 
  // LessScore less;
  // T t1, t2;
  //
  // then
  //
  // if (less(t1,t2)) ..
  //
  // will be interpreted as
  //
  // if (less.operator()(t1,t2))

  bool operator()(const Student& s1,const Student& s2) { 
    return s1.score() < s2.score(); }
};

int
main(int, char**) {
const unsigned int SIZE=3;
Student	students[SIZE];
students[2] = Student("A",20);
students[1] = Student("B",15);
students[0] = Student("C",10);

cout << "Before sorting:\n";
for (unsigned int i=0;(i<SIZE);++i)
	cout << students[i] << "\n";

cout << "Sorted by score:\n";
// Here we use our own LessScore class.
quicksort(students, 0, SIZE-1, LessScore());
for (unsigned int i=0;(i<SIZE);++i)
	cout << students[i] << "\n";

cout << "Sorted by name:\n";

// Here we use the less<Student> instantiation of the template class
// defined in the <functional> header file: less<T>::operator<() uses
// operator<(const T&, const T&) which, in our case, instantiates to
// operator<(const Student&, const Student&), i.e. name comparison.

quicksort(students, 0, SIZE-1, less<Student>());
for (unsigned int i=0;(i<SIZE);++i)
	cout << students[i] << "\n";

}
